package com.aliyun.vodplayer.demo.activity.advance;

import android.Manifest;
import android.content.DialogInterface;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.support.annotation.IdRes;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.alivc.player.AliVcMediaPlayer;
import com.alivc.player.AliyunErrorCode;
import com.alivc.player.VcPlayerLog;
import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.activity.basic.VodModeActivity;
import com.aliyun.vodplayer.demo.utils.BaseAppCompatActivity;
import com.aliyun.vodplayer.demo.utils.Formatter;
import com.aliyun.vodplayer.demo.utils.SaveBmpUtils;
import com.aliyun.vodplayer.media.AliyunLocalSource;
import com.aliyun.vodplayer.media.AliyunPlayAuth;
import com.aliyun.vodplayer.media.AliyunVidSource;
import com.aliyun.vodplayer.media.AliyunVidSts;
import com.aliyun.vodplayer.media.AliyunVodPlayer;
import com.aliyun.vodplayer.media.IAliyunVodPlayer;
import com.aliyun.vodplayerview.utils.NetWatchdog;
import com.aliyun.vodplayerview.utils.ScreenUtils;

import java.lang.ref.WeakReference;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static com.aliyun.vodplayer.media.IAliyunVodPlayer.PlayerState.Completed;
import static com.aliyun.vodplayer.media.IAliyunVodPlayer.PlayerState.Idle;
import static com.aliyun.vodplayer.media.IAliyunVodPlayer.PlayerState.Stopped;

public class NoSkinActivity extends BaseAppCompatActivity {

    private static final String TAG = NoSkinActivity.class.getSimpleName();

    private SimpleDateFormat format = new SimpleDateFormat("HH:mm:ss.SS");

    private SurfaceView surfaceView;

    private Button playBtn;
    private Button pauseBtn;
    private Button replayBtn;
    private Button stopBtn;

    private CheckBox autoPlayOnBtn;
    private CheckBox muteOnBtn;

    private RadioGroup scaleModeGroup;
    private RadioButton scaleModeFit;
    private RadioButton scaleModeFill;

    private RadioGroup speedGroup;
    private RadioButton speed10;
    private RadioButton speed125;
    private RadioButton speed15;
    private RadioButton speed20;
    private float speed = 1.0f;

    private RadioGroup rotateGroup;
    private RadioButton rotate0;
    private RadioButton rotate90;
    private RadioButton rotate180;
    private RadioButton rotate270;
    private IAliyunVodPlayer.VideoRotate roate;


    private RadioGroup mirrorGroup;
    private RadioButton mirrorN;
    private RadioButton mirrorH;
    private RadioButton mirrorV;
    private IAliyunVodPlayer.VideoMirrorMode mirrorMode;

    private LinearLayout qualityLayout;


    private TextView positionTxt;
    private TextView durationTxt;
    private SeekBar progressBar;

    private SeekBar brightnessBar;
    private SeekBar volumeBar;

    private TextView videoWidthTxt;
    private TextView videoHeightTxt;

    public static boolean sAutoPlay = false;
    public boolean mAutoPlay = false;
    private boolean mMute = false;
    private int mScalingMode = 1; //fill
    private List<String> mQualities = new ArrayList<>();
    private List<Button> qualityIds = new ArrayList<>();

    private List<String> logStrs = new ArrayList<>();

    private AliyunVodPlayer aliyunVodPlayer;
    private Handler handler = new Handler();

    private boolean replay = false;
    private boolean inSeek = false;
    private boolean isCompleted = false;

    private String mVid = null;
    private String mAuthinfo = null;
    private Map<String, String> qualityList = new HashMap<>();

    private AliyunPlayAuth mPlayAuth = null;
    private AliyunVidSource mVidSource = null;
    private AliyunLocalSource mLocalSource = null;
    private AliyunVidSts mVidSts = null;


    private AlertDialog netChangeDialog;
    private NetWatchdog netWatchdog;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_log, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId() == R.id.log) {

            LayoutInflater inflater = LayoutInflater.from(this);
            View view = inflater.inflate(R.layout.view_log, null);

            TextView textview = (TextView) view.findViewById(R.id.log);
            if (aliyunVodPlayer != null) {
                for (String log : logStrs) {
                    textview.append("     " + log + "\n");
                }
            }
            AlertDialog.Builder alertDialog = new AlertDialog.Builder(this);
            alertDialog.setTitle(R.string.player_log);
            alertDialog.setView(view);
            alertDialog.setPositiveButton(R.string.ok, null);
            AlertDialog alert = alertDialog.create();
            alert.show();
        }
        return true;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

        setContentView(R.layout.activity_noskin);
        surfaceView = (SurfaceView) findViewById(R.id.surfaceView);

        playBtn = (Button) findViewById(R.id.play);
        stopBtn = (Button) findViewById(R.id.stop);
        pauseBtn = (Button) findViewById(R.id.pause);
        replayBtn = (Button) findViewById(R.id.replay);

        qualityLayout = (LinearLayout) findViewById(R.id.quality);

        autoPlayOnBtn = (CheckBox) findViewById(R.id.autoPlayON);


        autoPlayOnBtn.setChecked(sAutoPlay);


        autoPlayOnBtn.setOnCheckedChangeListener(new CheckBox.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                sAutoPlay = buttonView.isChecked();
            }
        });

        muteOnBtn = (CheckBox) findViewById(R.id.muteOn);

        muteOnBtn.setOnCheckedChangeListener(new CheckBox.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (buttonView.isChecked()) {
                    mMute = true;
                    if (aliyunVodPlayer != null) {
                        aliyunVodPlayer.setMuteMode(mMute);
                    }
                    volumeBar.setProgress(0);
                } else {
                    mMute = false;
                    if (aliyunVodPlayer != null) {
                        aliyunVodPlayer.setMuteMode(mMute);
                    }
                    volumeBar.setProgress(aliyunVodPlayer.getVolume());
                }
            }


        });

        scaleModeGroup = (RadioGroup) findViewById(R.id.scalingMode);
        scaleModeFit = (RadioButton) findViewById(R.id.fit);
        scaleModeFill = (RadioButton) findViewById(R.id.fill);

        scaleModeFit.setChecked(true);

        scaleModeGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, @IdRes int checkedId) {
                if (checkedId == scaleModeFit.getId()) {
                    mScalingMode = 0;
                    if (aliyunVodPlayer != null) {
                        aliyunVodPlayer.setVideoScalingMode(IAliyunVodPlayer.VideoScalingMode.VIDEO_SCALING_MODE_SCALE_TO_FIT);
                    }
                } else if (checkedId == scaleModeFill.getId()) {
                    mScalingMode = 1;
                    if (aliyunVodPlayer != null) {
                        aliyunVodPlayer.setVideoScalingMode(IAliyunVodPlayer.VideoScalingMode.VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING);
                    }
                }
            }
        });


        speedGroup = (RadioGroup) findViewById(R.id.speedgroup);
        speed10 = (RadioButton) findViewById(R.id.speed10);
        speed125 = (RadioButton) findViewById(R.id.speed125);
        speed15 = (RadioButton) findViewById(R.id.speed15);
        speed20 = (RadioButton) findViewById(R.id.speed20);
        speed10.setChecked(true);
        speedGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, @IdRes int checkedId) {
                if (checkedId == R.id.speed125) {
                    speed = 1.25f;
                } else if (checkedId == R.id.speed10) {
                    speed = 1.0f;
                } else if (checkedId == R.id.speed15) {
                    speed = 1.5f;
                } else if (checkedId == R.id.speed20) {
                    speed = 2.0f;
                }

                if (aliyunVodPlayer != null) {
                    aliyunVodPlayer.setPlaySpeed(speed);
                }
            }
        });


        rotateGroup = (RadioGroup) findViewById(R.id.rotationgroup);
        rotate0 = (RadioButton) findViewById(R.id.rotate0);
        rotate90 = (RadioButton) findViewById(R.id.rotate90);
        rotate180 = (RadioButton) findViewById(R.id.rotate180);
        rotate270 = (RadioButton) findViewById(R.id.rotate270);
        rotate0.setChecked(true);
        rotateGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, @IdRes int checkedId) {
                if (checkedId == R.id.rotate0) {
                    roate = IAliyunVodPlayer.VideoRotate.ROTATE_0;
                } else if (checkedId == R.id.rotate90) {
                    roate = IAliyunVodPlayer.VideoRotate.ROTATE_90;
                } else if (checkedId == R.id.rotate180) {
                    roate = IAliyunVodPlayer.VideoRotate.ROTATE_180;
                } else if (checkedId == R.id.rotate270) {
                    roate = IAliyunVodPlayer.VideoRotate.ROTATE_270;
                }

                if (aliyunVodPlayer != null) {
                    aliyunVodPlayer.setRenderRotate(roate);
                }
            }
        });

        mirrorGroup = (RadioGroup) findViewById(R.id.mirrorroup);
        mirrorN = (RadioButton) findViewById(R.id.mirrornormal);
        mirrorH = (RadioButton) findViewById(R.id.mirrorh);
        mirrorV = (RadioButton) findViewById(R.id.mirrorv);
        mirrorN.setChecked(true);
        mirrorGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, @IdRes int checkedId) {
                if (checkedId == R.id.mirrornormal) {
                    mirrorMode = IAliyunVodPlayer.VideoMirrorMode.VIDEO_MIRROR_MODE_NONE;
                } else if (checkedId == R.id.mirrorh) {
                    mirrorMode = IAliyunVodPlayer.VideoMirrorMode.VIDEO_MIRROR_MODE_HORIZONTAL;
                } else if (checkedId == R.id.mirrorv) {
                    mirrorMode = IAliyunVodPlayer.VideoMirrorMode.VIDEO_MIRROR_MODE_VERTICAL;
                }

                if (aliyunVodPlayer != null) {
                    aliyunVodPlayer.setRenderMirrorMode(mirrorMode);
                }
            }
        });


        positionTxt = (TextView) findViewById(R.id.currentPosition);
        durationTxt = (TextView) findViewById(R.id.totalDuration);
        progressBar = (SeekBar) findViewById(R.id.progress);
        brightnessBar = (SeekBar) findViewById(R.id.brightnessProgress);
        volumeBar = (SeekBar) findViewById(R.id.volumeProgress);

        videoWidthTxt = (TextView) findViewById(R.id.width);
        videoHeightTxt = (TextView) findViewById(R.id.height);

        playBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mPlayerState = aliyunVodPlayer.getPlayerState();
                if (mPlayerState == Idle || mPlayerState == Stopped ||
                        mPlayerState == Completed) {
                    if (mVidSource != null) {
                        aliyunVodPlayer.prepareAsync(mVidSource);
                    } else if (mPlayAuth != null) {
                        aliyunVodPlayer.prepareAsync(mPlayAuth);
                    } else if (mLocalSource != null) {
                        aliyunVodPlayer.prepareAsync(mLocalSource);
                    } else if (mVidSts != null) {
                        aliyunVodPlayer.prepareAsync(mVidSts);
                    }
                    mAutoPlay = true;
                } else {
                    inSeek = false;
                    aliyunVodPlayer.start();
                    pauseBtn.setText(R.string.pause_button);
                }
                if (mMute) {
                    aliyunVodPlayer.setMuteMode(mMute);
                }
                brightnessBar.setProgress(aliyunVodPlayer.getScreenBrightness());
                logStrs.add(format.format(new Date()) + getString(R.string.log_strart_play));
                volumeBar.setProgress(aliyunVodPlayer.getVolume());
            }
        });
        stopBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (aliyunVodPlayer != null) {
                    aliyunVodPlayer.stop();
                }
            }
        });

        pauseBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mPlayerState = aliyunVodPlayer.getPlayerState();
                if (mPlayerState == IAliyunVodPlayer.PlayerState.Started) {
                    aliyunVodPlayer.pause();
                    pauseBtn.setText(R.string.resume_button);
                } else if (mPlayerState == IAliyunVodPlayer.PlayerState.Paused) {
                    aliyunVodPlayer.resume();
                    pauseBtn.setText(R.string.pause_button);
                }
            }
        });
        replayBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                isCompleted = false;
                inSeek = false;
                aliyunVodPlayer.replay();
                showVideoProgressInfo();

            }
        });


        progressBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {

            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                if (aliyunVodPlayer != null) {
                    aliyunVodPlayer.seekTo(seekBar.getProgress());
                    logStrs.add(format.format(new Date()) + getString(R.string.log_seek_start));
                    if (isCompleted) {
                        //播放完成了，不能seek了
                        inSeek = false;
                    } else {
                        inSeek = true;
                    }
                }
            }
        });

        brightnessBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {

                if (fromUser && aliyunVodPlayer != null) {
                    Log.d("lfj1009", "progress = " + progress);
                    aliyunVodPlayer.setScreenBrightness(progress);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        volumeBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {

                if (fromUser && aliyunVodPlayer != null) {
                    aliyunVodPlayer.setVolume(progress);
                    muteOnBtn.setChecked(false);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        surfaceView.getHolder().addCallback(new SurfaceHolder.Callback() {
            @Override
            public void surfaceCreated(SurfaceHolder holder) {
                Log.d(TAG, "surfaceCreated");
                aliyunVodPlayer.setDisplay(holder);
            }

            @Override
            public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
                Log.d(TAG, "surfaceChanged");
                aliyunVodPlayer.surfaceChanged();
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder holder) {
                Log.d(TAG, "surfaceDestroyed");
            }
        });

        initVodPlayer();
        setPlaySource();
        logStrs.add(format.format(new Date()) + getString(R.string.log_start_get_data));

        netWatchdog = new NetWatchdog(this);
        netWatchdog.setNetChangeListener(new NetWatchdog.NetChangeListener() {
            @Override
            public void onWifiTo4G() {
                if (aliyunVodPlayer.isPlaying()) {
                    aliyunVodPlayer.pause();
                }
                if (netChangeDialog == null || !netChangeDialog.isShowing()) {

                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(NoSkinActivity.this);
                    alertDialog.setTitle(getString(R.string.net_change_to_4g));
                    alertDialog.setMessage(getString(R.string.net_change_to_continue));
                    alertDialog.setPositiveButton(getString(R.string.ok), new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface, int i) {
                            if (aliyunVodPlayer.getPlayerState() == AliyunVodPlayer.PlayerState.Paused) {
                                aliyunVodPlayer.resume();
                            } else {

                                aliyunVodPlayer.stop();
                                aliyunVodPlayer.seekTo(progressBar.getProgress());
                                aliyunVodPlayer.start();
                            }
                        }
                    });
                    alertDialog.setNegativeButton(getString(R.string.no), null);
                    netChangeDialog = alertDialog.create();
                    netChangeDialog.show();
                }

                Toast.makeText(NoSkinActivity.this.getApplicationContext(), R.string.net_change_to_4g, Toast.LENGTH_SHORT).show();
            }

            @Override
            public void on4GToWifi() {
                Toast.makeText(NoSkinActivity.this.getApplicationContext(), R.string.net_change_to_wifi, Toast.LENGTH_SHORT).show();

            }

            @Override
            public void onNetDisconnected() {
                Toast.makeText(NoSkinActivity.this.getApplicationContext(), R.string.net_disconnect, Toast.LENGTH_SHORT).show();
            }
        });
        netWatchdog.startWatch();

        if (mVidSource != null) {
            aliyunVodPlayer.prepareAsync(mVidSource);
        } else if (mPlayAuth != null) {
            aliyunVodPlayer.prepareAsync(mPlayAuth);
        } else if (mLocalSource != null) {
            aliyunVodPlayer.prepareAsync(mLocalSource);
        } else if (mVidSts != null) {
            aliyunVodPlayer.prepareAsync(mVidSts);
        }

        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_FLUENT, getString(R.string.alivc_fd_definition));
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_LOW, getString(R.string.alivc_ld_definition));
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_STAND, getString(R.string.alivc_sd_definition));
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_HIGH, getString(R.string.alivc_hd_definition));
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_2K, getString(R.string.alivc_k2_definition));
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_4K, getString(R.string.alivc_k4_definition));
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_ORIGINAL, getString(R.string.alivc_od_definition));


        findViewById(R.id.snapshot).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Bitmap bitmap = aliyunVodPlayer.snapShot();
                boolean success = false;
                if (bitmap != null) {
                    success = SaveBmpUtils.saveBmp(bitmap, Environment.getExternalStorageDirectory().getAbsolutePath() + "/" + System.currentTimeMillis() + ".jpg");
                }

                if (success) {
                    Toast.makeText(NoSkinActivity.this.getApplicationContext(), R.string.snapshot_success, Toast.LENGTH_SHORT).show();
                } else {
                    Toast.makeText(NoSkinActivity.this.getApplicationContext(), R.string.snapshot_fail, Toast.LENGTH_SHORT).show();
                }
            }
        });
    }

    private void initVodPlayer() {
        aliyunVodPlayer = new AliyunVodPlayer(this);
        String sdDir = Environment.getExternalStorageDirectory().getAbsolutePath() + "/test_save_cache";
        aliyunVodPlayer.setPlayingCache(true, sdDir, 60 * 60 /*时长, s */, 300 /*大小，MB*/);
        aliyunVodPlayer.setCirclePlay(true);

        aliyunVodPlayer.setOnCircleStartListener(new MyCircleStartListener(this));
        aliyunVodPlayer.setOnPreparedListener(new MyPrepareListener(this));
        aliyunVodPlayer.setOnFirstFrameStartListener(new MyFirstFrameListener(this));
        aliyunVodPlayer.setOnErrorListener(new MyErrorListener(this));
        aliyunVodPlayer.setOnCompletionListener(new MyCompletionListener(this));
        aliyunVodPlayer.setOnSeekCompleteListener(new MySeekCompleteListener(this));
        aliyunVodPlayer.setOnStoppedListner(new MyStoppedListener(this));
        aliyunVodPlayer.setOnChangeQualityListener(new MyChangeQualityListener(this));

        aliyunVodPlayer.enableNativeLog();
    }

    private static class MyCircleStartListener implements IAliyunVodPlayer.OnCircleStartListener {
        private WeakReference<NoSkinActivity> activityWeakReference;

        public MyCircleStartListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }

        @Override
        public void onCircleStart() {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onCircleStart();
            }
        }
    }

    private void onCircleStart() {
        //循环播放开始
    }

    private static class MyPrepareListener implements IAliyunVodPlayer.OnPreparedListener {

        private WeakReference<NoSkinActivity> activityWeakReference;

        public MyPrepareListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }

        @Override
        public void onPrepared() {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onPrepared();
            }
        }
    }

    private void onPrepared() {
        Toast.makeText(NoSkinActivity.this.getApplicationContext(), R.string.toast_prepare_success, Toast.LENGTH_SHORT).show();
        logStrs.add(format.format(new Date()) + getString(R.string.log_prepare_success));


        qualityLayout.removeAllViews();

        if (mLocalSource == null) {
            qualityIds.clear();
            mQualities = aliyunVodPlayer.getMediaInfo().getQualities();
            String current = aliyunVodPlayer.getCurrentQuality();
            //update quality buttons
            int size = mQualities.size();
            for (int i = 0; i < size; i++) {
                String quality = mQualities.get(i);
                Button btn = new Button(getBaseContext());
                LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(
                        LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
                layoutParams.weight = 1;
                layoutParams.setMargins(10, 0, 10, 0);
                btn.setText(qualityList.get(quality));
                btn.setTextSize(14);
                btn.setTag(quality);
                //设置id，供自动化测试用
                int id = R.id.custom_id_min + i;
                btn.setId(id);

                btn.setTextColor(Color.rgb(49, 50, 51));
                btn.setBackgroundColor(Color.rgb(207, 207, 207));
                btn.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        changeQuality((Button) v);
                    }
                });
                if (current.equals(quality)) {
                    btn.setTextColor(Color.rgb(255, 255, 255));
                    btn.setBackgroundColor(Color.rgb(3, 106, 150));
                }
                qualityIds.add(btn);
                qualityLayout.addView(btn, layoutParams);

            }
        }


        if (sAutoPlay || mAutoPlay) {
            aliyunVodPlayer.start();
            pauseBtn.setText(R.string.pause_button);
            logStrs.add(format.format(new Date()) + getString(R.string.log_strart_play));
            if (mMute) {
                aliyunVodPlayer.setMuteMode(mMute);
            }
            brightnessBar.setProgress(aliyunVodPlayer.getScreenBrightness());
            volumeBar.setProgress(aliyunVodPlayer.getVolume());
        }
        mAutoPlay = false;
    }

    private static class MyFirstFrameListener implements IAliyunVodPlayer.OnFirstFrameStartListener {

        private WeakReference<NoSkinActivity> activityWeakReference;

        public MyFirstFrameListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }

        @Override
        public void onFirstFrameStart() {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onFirstFrameStart();
            }
        }
    }

    private void onFirstFrameStart() {

        //首帧显示之后再开始更新进度信息。
        inSeek = false;
        showVideoProgressInfo();
        showVideoSizeInfo();


        Map<String, String> debugInfo = aliyunVodPlayer.getAllDebugInfo();
        long createPts = 0;
        if (debugInfo.get("create_player") != null) {
            String time = debugInfo.get("create_player");
            createPts = (long) Double.parseDouble(time);
            logStrs.add(format.format(new Date(createPts)) + getString(R.string.log_player_create_success));
        }
        if (debugInfo.get("open-url") != null) {
            String time = debugInfo.get("open-url");
            long openPts = (long) Double.parseDouble(time) + createPts;
            logStrs.add(format.format(new Date(openPts)) + getString(R.string.log_open_url_success));
        }
        if (debugInfo.get("find-stream") != null) {
            String time = debugInfo.get("find-stream");
            VcPlayerLog.d(TAG + "lfj0914", "find-Stream time =" + time + " , createpts = " + createPts);
            long findPts = (long) Double.parseDouble(time) + createPts;
            logStrs.add(format.format(new Date(findPts)) + getString(R.string.log_request_stream_success));
        }
        if (debugInfo.get("open-stream") != null) {
            String time = debugInfo.get("open-stream");
            VcPlayerLog.d(TAG + "lfj0914", "open-Stream time =" + time + " , createpts = " + createPts);
            long openPts = (long) Double.parseDouble(time) + createPts;
            logStrs.add(format.format(new Date(openPts)) + getString(R.string.log_start_open_stream));
        }
        logStrs.add(format.format(new Date()) + getString(R.string.log_first_frame_played));
    }

    private static class MyErrorListener implements IAliyunVodPlayer.OnErrorListener {

        private WeakReference<NoSkinActivity> activityWeakReference;

        public MyErrorListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }

        @Override
        public void onError(int arg0, int arg1, String msg) {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onError(arg0, arg1, msg);
            }
        }
    }

    private void onError(int arg0, int arg1, String msg) {

        if (aliyunVodPlayer != null) {
            aliyunVodPlayer.stop();
        }

        if (arg0 == AliyunErrorCode.ALIVC_ERR_INVALID_INPUTFILE.getCode()) {
            //当播放本地报错4003的时候，可能是文件地址不对，也有可能是没有权限。
            //如果是没有权限导致的，就做一个权限的错误提示。其他还是正常提示：
            int storagePermissionRet = ContextCompat.checkSelfPermission(NoSkinActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
            if (storagePermissionRet != PackageManager.PERMISSION_GRANTED) {
                Toast.makeText(NoSkinActivity.this.getApplicationContext(), getString(R.string.toast_fail_msg) + getString(R.string.toast_no_local_storage_permission), Toast.LENGTH_SHORT).show();
                return;
            }
        }

        Toast.makeText(NoSkinActivity.this.getApplicationContext(), getString(R.string.toast_fail_msg) + msg, Toast.LENGTH_SHORT).show();
    }

    private static class MyCompletionListener implements IAliyunVodPlayer.OnCompletionListener {
        private WeakReference<NoSkinActivity> activityWeakReference;

        public MyCompletionListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }

        @Override
        public void onCompletion() {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onCompletion();
            }
        }
    }

    private void onCompletion() {
        Log.d(TAG, "onCompletion--- ");
        isCompleted = true;
        inSeek = false;
        showVideoProgressInfo();
        stopUpdateTimer();
    }

    private static class MySeekCompleteListener implements IAliyunVodPlayer.OnSeekCompleteListener {

        private WeakReference<NoSkinActivity> activityWeakReference;

        public MySeekCompleteListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }

        @Override
        public void onSeekComplete() {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onSeekComplete();
            }
        }
    }

    private void onSeekComplete() {
        logStrs.add(format.format(new Date()) + getString(R.string.log_seek_completed));
        inSeek = false;
    }

    private static class MyStoppedListener implements IAliyunVodPlayer.OnStoppedListener {
        private WeakReference<NoSkinActivity> activityWeakReference;

        public MyStoppedListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }


        @Override
        public void onStopped() {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onStopped();
            }
        }
    }

    private void onStopped() {
        logStrs.add(format.format(new Date()) + getString(R.string.log_play_stopped));
        if (replay) {
            logStrs.add(format.format(new Date()) + getString(R.string.log_start_get_data));
            if (mVidSource != null) {
                aliyunVodPlayer.prepareAsync(mVidSource);
            } else if (mPlayAuth != null) {
                aliyunVodPlayer.prepareAsync(mPlayAuth);
            } else if (mLocalSource != null) {
                aliyunVodPlayer.prepareAsync(mLocalSource);
            } else if (mVidSts != null) {
                aliyunVodPlayer.prepareAsync(mVidSts);
            }
            mAutoPlay = true;
        }
        replay = false;
        inSeek = false;
    }

    private static class MyChangeQualityListener implements IAliyunVodPlayer.OnChangeQualityListener {

        private WeakReference<NoSkinActivity> activityWeakReference;

        public MyChangeQualityListener(NoSkinActivity skinActivity) {
            activityWeakReference = new WeakReference<NoSkinActivity>(skinActivity);
        }

        @Override
        public void onChangeQualitySuccess(String finalQuality) {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onChangeQualitySuccess(finalQuality);
            }
        }

        @Override
        public void onChangeQualityFail(int code, String msg) {
            NoSkinActivity activity = activityWeakReference.get();
            if (activity != null) {
                activity.onChangeQualityFail(code, msg);
            }
        }
    }

    private void onChangeQualitySuccess(String finalQuality) {
        Log.d(TAG, "onChangeQualitySuccess");
        inSeek = false;
        logStrs.add(format.format(new Date()) + getString(R.string.log_change_quality_success));
        showVideoProgressInfo();
    }


    private void onChangeQualityFail(int code, String msg) {
        Log.d(TAG, "onChangeQualityFail。。。" + code + " ,  " + msg);
        logStrs.add(format.format(new Date()) + getString(R.string.log_change_quality_fail));
    }


    private void changeQuality(Button v) {
        if (aliyunVodPlayer != null &&
                (aliyunVodPlayer.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused
                        || aliyunVodPlayer.getPlayerState() == IAliyunVodPlayer.PlayerState.Started ||
                        aliyunVodPlayer.getPlayerState() == IAliyunVodPlayer.PlayerState.Error)) {
            Button fouces = v;
            fouces.setTextColor(Color.rgb(255, 255, 255));
            fouces.setBackgroundColor(Color.rgb(3, 106, 150));
            logStrs.add(format.format(new Date()) + getString(R.string.log_change_quality) + fouces.getText());
            //refreshPlaySource();
            aliyunVodPlayer.changeQuality((String) fouces.getTag());
            for (Button otherBtn : qualityIds) {
                if (!otherBtn.equals(fouces)) {
                    otherBtn.setTextColor(Color.rgb(49, 50, 51));
                    otherBtn.setBackgroundColor(getResources().getColor(R.color.alivc_info_text_duration));
                }
            }

        }
    }

    private void setPlaySource() {


        String type = getIntent().getStringExtra("type");
        if ("authInfo".equals(type)) {
            //auth方式

            //NOTE： 注意过期时间。特别是重播的时候，可能已经过期。所以重播的时候最好重新请求一次服务器。
            mVid = getIntent().getStringExtra("vid").toString();
            String authInfo = getIntent().getStringExtra("authinfo");
            AliyunPlayAuth.AliyunPlayAuthBuilder aliyunPlayAuthBuilder = new AliyunPlayAuth.AliyunPlayAuthBuilder();
            aliyunPlayAuthBuilder.setVid(mVid);
            aliyunPlayAuthBuilder.setPlayAuth(authInfo);
            aliyunPlayAuthBuilder.setQuality(IAliyunVodPlayer.QualityValue.QUALITY_LOW);
            //aliyunVodPlayer.setAuthInfo(aliyunPlayAuthBuilder.build());
            mPlayAuth = aliyunPlayAuthBuilder.build();
        } else if ("localSource".equals(type)) {
            //本地播放
            String url = getIntent().getStringExtra("url");
            AliyunLocalSource.AliyunLocalSourceBuilder asb = new AliyunLocalSource.AliyunLocalSourceBuilder();
            asb.setSource(url);
            //aliyunVodPlayer.setLocalSource(asb.build());
            mLocalSource = asb.build();
        } else if ("vidSource".equals(type)) {
            mVid = getIntent().getStringExtra("vid").toString();
            mVidSource = new AliyunVidSource();
            String authInfo = getIntent().getStringExtra("authinfo");
            String token = getIntent().getStringExtra("token");
            String akid = getIntent().getStringExtra("akid");
            String aks = getIntent().getStringExtra("aks");
            mVidSource.setVid(mVid);
            mVidSource.setAuthInfo(authInfo);
            mVidSource.setStsToken(token);
            mVidSource.setAcKey(aks);
            mVidSource.setAcId(akid);
            mVidSource.setDomainRegion("cn-shanghai");
            mVidSource.setHlsUriToken("hlsuritokenaaaa");
            //mVidSource.setDomain("vod-test5.cn-shanghai.aliyuncs.com");
//             mVidSource.setDomain("jiyoujia.com");
        } else if ("vidsts".equals(type)) {
            mVid = getIntent().getStringExtra("vid").toString();

            String akid = getIntent().getStringExtra("akId");
            String aks = getIntent().getStringExtra("akSecret");
            String token = getIntent().getStringExtra("securityToken");

            mVidSts = new AliyunVidSts();
            mVidSts.setVid(mVid);
            mVidSts.setAcId(akid);
            mVidSts.setAkSceret(aks);
            mVidSts.setSecurityToken(token);

        }
    }

    private void showVideoSizeInfo() {
        videoWidthTxt.setText(getString(R.string.video_width) + aliyunVodPlayer.getVideoWidth() + " , ");
        videoHeightTxt.setText(getString(R.string.video_height) + aliyunVodPlayer.getVideoHeight() + "   ");
    }

    private void showVideoProgressInfo() {
        if (aliyunVodPlayer != null && !inSeek) {
            int curPosition = (int) aliyunVodPlayer.getCurrentPosition();
            positionTxt.setText(Formatter.formatTime(curPosition));
            int duration = (int) aliyunVodPlayer.getDuration();
            durationTxt.setText(Formatter.formatTime(duration));
            Log.d(TAG, "lfj0918 duration = " + duration + " , curPosition = " + curPosition);
            int bufferPosition = aliyunVodPlayer.getBufferingPosition();
            progressBar.setMax(duration);
            progressBar.setSecondaryProgress(bufferPosition);
            progressBar.setProgress(curPosition);
        }

        startUpdateTimer();
    }

    private void startUpdateTimer() {
        Log.d(TAG, "startUpdateTimer--- ");
        progressUpdateTimer.removeMessages(0);
        progressUpdateTimer.sendEmptyMessageDelayed(0, 1000);
    }

    private void stopUpdateTimer() {
        progressUpdateTimer.removeMessages(0);
    }

    private Handler progressUpdateTimer = new Handler() {
        @Override
        public void handleMessage(Message msg) {

            showVideoProgressInfo();
        }
    };

    @Override
    protected void onResume() {
        super.onResume();
        //保存播放器的状态，供resume恢复使用。
        resumePlayerState();
    }

    @Override
    protected void onStop() {
        super.onStop();
        //onStop中记录下来的状态，在这里恢复使用
        savePlayerState();
    }


    //用来记录前后台切换时的状态，以供恢复。
    private IAliyunVodPlayer.PlayerState mPlayerState;

    private void resumePlayerState() {
        if (mPlayerState == IAliyunVodPlayer.PlayerState.Paused) {
            aliyunVodPlayer.pause();
        } else if (mPlayerState == IAliyunVodPlayer.PlayerState.Started) {
            aliyunVodPlayer.start();
            pauseBtn.setText(R.string.pause_button);
        }
    }

    private void savePlayerState() {
        mPlayerState = aliyunVodPlayer.getPlayerState();
        if (aliyunVodPlayer.isPlaying()) {
            //然后再暂停播放器
            aliyunVodPlayer.pause();
        }
    }

    @Override
    protected void onDestroy() {
        aliyunVodPlayer.stop();
        aliyunVodPlayer.release();
        stopUpdateTimer();
        progressUpdateTimer = null;

        super.onDestroy();
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        int orientation = getResources().getConfiguration().orientation;
        if (orientation == Configuration.ORIENTATION_PORTRAIT) {                //转为竖屏了。
            //显示状态栏
            this.getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
            surfaceView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_VISIBLE);

            //设置view的布局，宽高之类
            ViewGroup.LayoutParams surfaceViewLayoutParams = surfaceView.getLayoutParams();
            surfaceViewLayoutParams.height = (int) (ScreenUtils.getWidth(this) * 9.0f / 16);
            surfaceViewLayoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;

        } else if (orientation == Configuration.ORIENTATION_LANDSCAPE) {                //转到横屏了。
            //隐藏状态栏
            this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
            surfaceView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                    | View.SYSTEM_UI_FLAG_FULLSCREEN);
            //设置view的布局，宽高
            ViewGroup.LayoutParams surfaceViewLayoutParams = surfaceView.getLayoutParams();
            surfaceViewLayoutParams.height = ViewGroup.LayoutParams.MATCH_PARENT;
            surfaceViewLayoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;

        }
    }
}
