package com.aliyun.vodplayer.demo.activity.advance.liveanswer.bean;

import android.text.TextUtils;

import com.aliyun.vodplayer.utils.JsonUtil;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

/*
 * Copyright (C) 2010-2017 Alibaba Group Holding Limited.
 */
public class QuestionInfo {
    public String questionId;//string	是	题目ID
    public String questionTitle;//	string	是	题干
    public OptionInfo options[];//	Option[]	是	选项列表
    public int remainSeconds = 10;//	int	是	答题剩余秒数
    public int totalUserNumber;//答题总人数


    public static QuestionInfo getFromJson(JSONObject questionJson){

        if(questionJson == null){
            return null;
        }

        QuestionInfo questionInfo = new QuestionInfo();
        questionInfo.questionId = JsonUtil.getString(questionJson,"questionId");
        questionInfo.questionTitle = JsonUtil.getString(questionJson,"questionTitle");
        JSONArray options = JsonUtil.getArray(questionJson, "options");
        questionInfo.options = OptionInfo.getFromArray(options);
        questionInfo.remainSeconds = JsonUtil.getInt(questionJson,"remainSeconds");
        questionInfo.totalUserNumber = JsonUtil.getInt(questionJson,"totalUserNumber");


        return questionInfo;

    }
}
